<?php
// define variables 
$file_path = 'test-data.csv';
$default_email = 'default@test.com';
$num = 10; // number of ads to import per request

define('DB_NO_UTF8', true);
define('SCRIPT_NAME', 'from_csv');
define('IMAGE_URL_PREFIX', 'http://yoursite.com/adpics/');


/* setup dev user by ip. good to test on live server */
$arr_myip = array('127.0.0.1', '127.0.0.1');

function is_dev()
{
	global $arr_myip;
	if(defined('REMOTE_ADDR'))
	{
		return in_array(REMOTE_ADDR, $arr_myip);
	}
	return false;
}


define('REQUEST_TIME', $_SERVER['REQUEST_TIME']);
define('REMOTE_ADDR', $_SERVER['REMOTE_ADDR']);
define('DEMO', 0);

// if developer then 
if(is_dev())
{
	define('DEBUG', true);
// turn error reporting on 
	error_reporting(E_ALL);
	ini_set('display_errors', '1');
}
else
{
	define('DEBUG', false);
}

// if your server doesn't have PDO (with MySQL driver) set the below to false
define('USE_PDO', '1');

// Set the timezone of your choise
// go here for more information of the available timezone:
// http://php.net/timezones GMT
define('DEFAULT_TIMEZONE', 'GMT');


// include framework
include 'Framework.php';


// set page
$page = intval($_GET['page']);
if($page < 1)
{
	$page = 1;
}
$st = ($page - 1) * $num;

// connect 
switch(SCRIPT_NAME)
{
	case 'from_csv':	
		$lines = file($file_path);
	
		$cur_lines = array_slice($lines,$st,$num);
	
		if(!$cur_lines)
		{
			exit;
		}
		// requires php version > 5.3
		$csv = array_map('str_getcsv', $cur_lines);
		
		/*Array
		(
			[0] => Array
				(
					[0] => title
					[1] => description
					[2] => address
					[3] => city
					[4] => state
					[5] => phone
					[6] => website
					[7] => email
					[8] => category
					[9] => subcategory
				)

			[1] => Array
				(
					[0] => Electric Co. 7
					[1] => Best electric company in region 7
					[2] => Industriel str. 129/12
					[3] => City One
					[4] => State Three
					[5] => 54654654
					[6] => 
					[7] => 
					[8] => Category One
					[9] => Subcat One
				)

			[2] => Array
				(
					[0] => Electric Co. 8
					[1] => Best electric company in region 8
					[2] => Industriel str. 129/12
					[3] => City Two
					[4] => State Three
					[5] => 87878787878
					[6] => 
					[7] => 
					[8] => Category One
					[9] => Subcat Two
				)
		*/
		
		$m = array(
			'title'=>0,
			'description'=>1,
			'address'=>2,
			'city'=>3,
			'state'=>4,
			'phone'=>5,
			'website'=>6,
			'email'=>7,
			'category'=>8,
			'subcategory'=>9
		);
		//print_r($csv);
		//exit;

		
		$link = '';

		header("Content-Type: application/xml; charset=UTF-8");

		echo '<?xml version="1.0" encoding="UTF-8" ?>
			<rss version="2.0">
				<channel>
					<title>SCRIPT_NAME:' . SCRIPT_NAME . '</title>
				    <description>Export xml. current page:' . $page . ' . to load next page use ?page=' . ($page + 1) . '</description>
				';

		foreach($csv as $ad)
		{			
			// custom fields
			$custom_fields = array();
			
			if($ad[$m['website']])
			{
				$custom_fields[] = '<customfield>
										<name>Website</name>
										<value>' . View::escape($ad[$m['website']]) . '</value>
										<type>url</type>
										<defined></defined>
										<is_search>1</is_search>
										<is_list>1</is_list>
									</customfield>
									';
			}
			if($ad[$m['address']])
			{
				$custom_fields[] = '<customfield>
										<name>Address</name>
										<value>' . View::escape($ad[$m['address']]) . '</value>
										<type>address</type>
										<defined></defined>
										<is_search>0</is_search>
										<is_list>0</is_list>
									</customfield>
									';
			}

			// $link = Ad::url($ad);	
			$email = $ad[$m['email']];
			if(!strlen($email))
			{
				$email = $default_email;
				$showemail = 0;
			}
			else
			{
				$showemail = 1;
			}
			echo '<item>
					<title>' . View::escape($ad[$m['title']]) . '</title>
					<link>' . $link . '</link>
					<description>' . View::escape($ad[$m['description']]) . '</description>		
					<pubDate>' . date('r', REQUEST_TIME) . '</pubDate>
					<verified>1</verified>
					<enabled>1</enabled>
					<email>' . View::escape($email) . '</email>
					<showemail>'.$showemail.'</showemail>
					<phone>' . $ad[$m['phone']] . '</phone>					
					<ip>' . View::escape('0.0.0.0') . '</ip>
					<location>' . formatValues(array($ad[$m['state']], $ad[$m['city']])) . '</location>
					<category>' . formatValues(array($ad[$m['category']], $ad[$m['subcategory']])) . '</category>
					' . implode('', $custom_fields) . '
				</item>
				';
		}

		echo '</channel>
			</rss>';




		//print_r($ads);
		//exit;
		break;
	default :
		exit(SCRIPT_NAME . ' script not supported.');
}

function formatValues($array = array())
{
	$arr_ = array();
	if($array)
	{
		foreach($array as $val)
		{
			if(strlen(trim($val)) > 0)
			{
				$arr_[] = View::escape($val);
			}
		}
	}

	if($arr_)
	{

		return '<val>' . implode('</val><val>', $arr_) . '</val>';
	}
	return '';
}

//display_benchmark();